Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members

# DL_GroupParameters_EC< EC > Class Template Reference

`#include <eccrypto.h>`

Inheritance diagram for DL_GroupParameters_EC< EC >:

List of all members.

## Detailed Description

### template<class EC>
class DL_GroupParameters_EC< EC >

Elliptic Curve Parameters.

This class corresponds to the ASN.1 sequence of the same name in ANSI X9.62 (also SEC 1).

Definition at line 25 of file eccrypto.h.

## Public Types
typedef EC | EllipticCurve
typedef EllipticCurve::Point | Point
typedef Point | Element
typedef IncompatibleCofactorMultiplication | DefaultCofactorOption
typedef EcPrecomputation< EC > | GroupPrecomputation
typedef DL_FixedBasePrecomputationImpl< typenameEcPrecomputation< EC >::Element > | BasePrecomputation
## Public Member Functions
| DL_GroupParameters_EC ()
| DL_GroupParameters_EC (const OID &oid)
| DL_GroupParameters_EC (const EllipticCurve &ec, const Point &G, const Integer &n, const Integer &k=Integer::Zero())
| DL_GroupParameters_EC (BufferedTransformation &bt)
void | Initialize (const EllipticCurve &ec, const Point &G, const Integer &n, const Integer &k=Integer::Zero())
void | Initialize (const OID &oid)
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| to be implemented by derived classes, users should use one of the above functions instead
void | AssignFrom (const NameValuePairs &source)
| assign values from source to this object
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
| this implementation doesn't actually generate a curve, it just initializes the parameters with existing values
const DL_FixedBasePrecomputation< Element > & | GetBasePrecomputation () const
DL_FixedBasePrecomputation< Element > & | AccessBasePrecomputation ()
const Integer & | GetSubgroupOrder () const
Integer | GetCofactor () const
bool | ValidateGroup (RandomNumberGenerator &rng, unsigned int level) const
bool | ValidateElement (unsigned int level, const Element &element, const DL_FixedBasePrecomputation< Element > *precomp) const
bool | FastSubgroupCheckAvailable () const
void | EncodeElement (bool reversible, const Element &element, byte *encoded) const
unsigned int | GetEncodedElementSize (bool reversible) const
Element | DecodeElement (const byte *encoded, bool checkForGroupMembership) const
Integer | ConvertElementToInteger (const Element &element) const
Integer | GetMaxExponent () const
bool | IsIdentity (const Element &element) const
void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
OID | GetAlgorithmID () const
Element | MultiplyElements (const Element &a, const Element &b) const
Element | CascadeExponentiate (const Element &element1, const Integer &exponent1, const Element &element2, const Integer &exponent2) const
void | BERDecode (BufferedTransformation &bt)
void | DEREncode (BufferedTransformation &bt) const
void | SetPointCompression (bool compress)
bool | GetPointCompression () const
void | SetEncodeAsOID (bool encodeAsOID)
bool | GetEncodeAsOID () const
const EllipticCurve & | GetCurve () const
bool | operator== (const ThisClass &rhs) const
const DL_GroupPrecomputation< Element > & | GetGroupPrecomputation () const
| DL_GroupParameters ()
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| check this object for errors
bool | SupportsPrecomputation () const
void | Precompute (unsigned int precomputationStorage=16)
| do precomputation
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| retrieve previously saved precomputation
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| save precomputation for later use
virtual const Element & | GetSubgroupGenerator () const
virtual void | SetSubgroupGenerator (const Element &base)
virtual Element | ExponentiateBase (const Integer &exponent) const
virtual Element | ExponentiateElement (const Element &base, const Integer &exponent) const
virtual Integer | GetGroupOrder () const
virtual void | EncodeElement (bool reversible, const Element &element, byte *encoded) const =0
virtual Integer | ConvertElementToInteger (const Element &element) const =0
virtual bool | ValidateElement (unsigned int level, const Element &element, const DL_FixedBasePrecomputation< Element > *precomp) const =0
virtual bool | IsIdentity (const Element &element) const =0
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const =0
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| calls the above function with a NameValuePairs object that just specifies "KeySize"
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| throws InvalidMaterial if this object fails Validate() test
virtual void | Save (BufferedTransformation &bt) const
| save key into a BufferedTransformation
virtual void | Load (BufferedTransformation &bt)
| load key from a BufferedTransformation
void | DoQuickSanityCheck () const
template<class T>
bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T>
bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T>
bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
## Static Public Member Functions
static std::string | StaticAlgorithmNamePrefix ()
static OID | GetNextRecommendedParametersOID (const OID &oid)
static void __cdecl | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch
## Protected Member Functions
unsigned int | FieldElementLength () const
unsigned int | ExponentLength () const
void | ParametersChanged ()
## Protected Attributes
OID | m_oid
Integer | m_n
bool | m_compress
bool | m_encodeAsOID
Integer | m_k
EcPrecomputation< EC > | m_groupPrecomputation
DL_FixedBasePrecomputationImpl< typenameEcPrecomputation< EC >::Element > | m_gpc

## Member Function Documentation

template<class EC>
void DL_GroupParameters_EC< EC >::AssignFrom | ( | const NameValuePairs & | source | ) | `[virtual]`

| assign values from source to this object Note: This function can be used to create a public key from a private key. Implements CryptoMaterial. Definition at line 409 of file eccrypto.cpp. References Name::Cofactor(), Name::Curve(), NameValuePairs::GetRequiredParameter(), NameValuePairs::GetValue(), NameValuePairs::GetValueWithDefault(), Name::GroupOID(), DL_GroupParameters_EC< EC >::Initialize(), Name::SubgroupGenerator(), Name::SubgroupOrder(), and Integer::Zero(). Referenced by DL_GroupParameters_EC< EC >::GenerateRandom().

template<class EC>
void DL_GroupParameters_EC< EC >::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | alg
| ) | `[virtual]`

| this implementation doesn't actually generate a curve, it just initializes the parameters with existing values parameters: (Curve, SubgroupGenerator, SubgroupOrder, Cofactor (optional)), or (GroupOID) Reimplemented from GeneratableCryptoMaterial. Definition at line 430 of file eccrypto.cpp. References DL_GroupParameters_EC< EC >::AssignFrom().

bool DL_GroupParameters< typenameEcPrecomputation< EC >::Element >::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) | const`[inline, virtual, inherited]`

  | check this object for errors Parameters:
  | level | denotes the level of thoroughness: 0 - using this object won't cause a crash or exception (rng is ignored) 1 - this object will probably function (encrypt, sign, etc.) correctly (but may not check for weak keys and such) 2 - make sure this object will function correctly, and do reasonable security checks 3 - do checks that may take a long time
Returns: true if the tests pass Implements CryptoMaterial. Definition at line 531 of file pubkey.h.

bool DL_GroupParameters< typenameEcPrecomputation< EC >::Element >::SupportsPrecomputation | ( |  | ) | const`[inline, virtual, inherited]`

| Returns: whether this object supports precomputation Reimplemented from CryptoMaterial. Definition at line 555 of file pubkey.h.

void DL_GroupParameters< typenameEcPrecomputation< EC >::Element >::Precompute | ( | unsigned int | precomputationStorage = `16` | ) | `[inline, virtual, inherited]`

| do precomputation The exact semantics of Precompute() is varies, but typically it means calculate a table of n objects that can be used later to speed up computation. Reimplemented from CryptoMaterial. Definition at line 557 of file pubkey.h.

virtual void CryptoMaterial::Load | ( | BufferedTransformation & | bt | ) | `[inline, virtual, inherited]`

  | load key from a BufferedTransformation Exceptions:
  | KeyingErr | if decode fails
Note: Generally does not check that the key is valid. Call ValidateKey() or ThrowIfInvalidKey() to check that. Reimplemented in ASN1CryptoMaterial. Definition at line 994 of file cryptlib.h.

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value
| ) | const`[inline, inherited]`

| get a named value with type int used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case) Definition at line 278 of file cryptlib.h. Referenced by InvertibleRWFunction::GenerateRandom(), InvertibleRSAFunction::GenerateRandom(), InvertibleRabinFunction::GenerateRandom(), InvertibleLUCFunction::GenerateRandom(), DL_GroupParameters_IntegerBased::GenerateRandom(), DL_GroupParameters_DSA::GenerateRandom(), InvertibleESIGNFunction::GenerateRandom(), and Integer::GenerateRandomNoThrow().

The documentation for this class was generated from the following files:

- eccrypto.h
- eccrypto.cpp